    package com.zoraldia.openoffice;



    import com.sun.star.beans.NamedValue;
    import com.sun.star.comp.loader.FactoryHelper;
    import com.sun.star.frame.XController;
    import com.sun.star.frame.XModel;
    import com.sun.star.lang.IllegalArgumentException;
    import com.sun.star.lang.XMultiServiceFactory;
    import com.sun.star.lang.XSingleServiceFactory;
    import com.sun.star.lib.uno.helper.WeakBase;
    import com.sun.star.registry.XRegistryKey;
    import com.sun.star.task.XJob;
    import com.sun.star.ui.XContextMenuInterception;
    import com.sun.star.ui.XContextMenuInterceptor;
    import com.sun.star.uno.AnyConverter;
    import com.sun.star.uno.Exception;
    import com.sun.star.uno.Type;
    import com.sun.star.uno.UnoRuntime;
    import com.sun.star.uno.XComponentContext;

    public final class JobExecutor {

       public static class _JobExecutor extends WeakBase implements XJob {

          XComponentContext m_xContext;

          public _JobExecutor(XComponentContext context)
          {
             System.out.println("JobExecutor initialized.");
              m_xContext = context;
          }

          @Override
          public Object execute(NamedValue[] args)
                throws IllegalArgumentException, Exception {

             XModel xModel = null;
             boolean correctEvent = false;

             for (NamedValue arg : args) {
                if (arg.Name.equals("Environment")) {
                   NamedValue[] values = (NamedValue[]) AnyConverter.toObject(
                         new Type("[]com.sun.star.beans.NamedValue"),
                         arg.Value);
                   for (NamedValue value : values) {
                      if (value.Name.equals("EnvType")
                            && value.Value.equals("DOCUMENTEVENT")) {
                         correctEvent = true;
                      } else if (value.Name.equals("EventName")) {

                      } else if (value.Name.equals("Model")) {
                         xModel = (XModel) UnoRuntime.queryInterface(XModel.class,
                               value.Value);
                      }
                   }
                }
             }
             if (correctEvent) {
                MyContextMenuInterceptor interceptor = new MyContextMenuInterceptor();
                XContextMenuInterceptor xInterceptor = (XContextMenuInterceptor) UnoRuntime
                      .queryInterface(XContextMenuInterceptor.class,
                            interceptor);
                XController xController = xModel.getCurrentController();
                XContextMenuInterception xInterception = (XContextMenuInterception) UnoRuntime.queryInterface(XContextMenuInterception.class, xController);
                xInterception.registerContextMenuInterceptor(xInterceptor);

                System.out.println("Context menu interceptor has been registered.");
             }
             return null;
          }
       }

       private static final String __serviceName = "mytools.example.Job";
       private static final String[] __services = { __serviceName };

       public static XSingleServiceFactory __getServiceFactory(String implName,
             XMultiServiceFactory multiFactory, XRegistryKey regKey) {
          XSingleServiceFactory xSingleServiceFactory = null;

          if (implName.equals(JobExecutor._JobExecutor.class.getName())) {
             xSingleServiceFactory = FactoryHelper.getServiceFactory(
                   JobExecutor._JobExecutor.class, __serviceName,
                   multiFactory, regKey);
          }
          return xSingleServiceFactory;
       }

       public static boolean __writeRegistryServiceInfo(XRegistryKey regKey) {

          String impl = JobExecutor._JobExecutor.class.getName();
          for (String service : __services) {
             if (!FactoryHelper.writeRegistryServiceInfo(impl, service, regKey)) {
                return false;
             }
          }
          return true;
       }
    }